=== khtml/CMakeLists.txt ===

project(khtml)
KDE4_NO_ENABLE_FINAL(khtml)

add_definitions(-DKDE_DEFAULT_DEBUG_AREA=6000)

########svg#########
add_definitions(-DENABLE_SVG)
add_definitions(-DENABLE_SVG_FONTS)
add_definitions(-DWTF_PLATFORM_QT)
########svg#########

add_subdirectory( tests )

find_package(JPEG)
set_package_properties(JPEG PROPERTIES DESCRIPTION "JPEG image format support"
                       URL "http://www.ijg.org"
                       TYPE REQUIRED
                       PURPOSE "Required by khtml"
                      )

find_package(GIF)
set_package_properties(GIF PROPERTIES DESCRIPTION "GIF image format support"
                       URL "http://sourceforge.net/projects/giflib"
                       TYPE REQUIRED
                       PURPOSE "Required by khtml"
                      )

find_package(PNG)
set_package_properties(PNG PROPERTIES DESCRIPTION "PNG image format support"
                       URL "http://www.libpng.org/pub/png"
                       TYPE REQUIRED
                       PURPOSE "Required by khtml"
                      )

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${KDE4_ENABLE_EXCEPTIONS}")

configure_file(config-khtml.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-khtml.h )

set(khtmlgraphics_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/AffineTransform.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/FloatPoint.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/FloatRect.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/FloatSize.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/IntRect.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/Path.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/GraphicsTypes.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/PathTraversalState.cpp
  #${CMAKE_SOURCE_DIR}/khtml/platform/graphics/Image.cpp
  #${CMAKE_SOURCE_DIR}/khtml/platform/MIMETypeRegistry.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/AffineTransformQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/FloatPointQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/FloatRectQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/IntPointQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/IntRectQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/IntSizeQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/platform/graphics/qt/PathQt.cpp
  #${CMAKE_SOURCE_DIR}/khtml/platform/qt/MIMETypeRegistryQt.cpp
)

set(khtmlsvg_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGDocument.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGSVGElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStyledLocatableElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGLocatable.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStyledElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStylable.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGLength.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTransformable.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTransform.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGAngle.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGDocumentExtensions.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGParserUtilities.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTransformDistance.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTransformList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStringList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStyledTransformableElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTests.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGLangSpace.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGExternalResourcesRequired.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGRectElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPreserveAspectRatio.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGFitToViewBox.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGCircleElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStyleElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGEllipseElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPointList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGAnimatedPoints.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPolyElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPolygonElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPolylineElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGAnimatedPathData.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegArc.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegClosePath.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegCurvetoCubic.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegCurvetoCubicSmooth.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegCurvetoQuadratic.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegCurvetoQuadraticSmooth.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegLineto.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegLinetoHorizontal.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegLinetoVertical.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathSegMoveto.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGPathElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGURIReference.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGStopElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGGradientElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGLinearGradientElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGRadialGradientElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGDefsElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGClipPathElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGGElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGElementInstance.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGElementInstanceList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGUseElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGLineElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTextPathElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTextContentElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGNumberList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTextPositioningElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGLengthList.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTextElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGAElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGScriptElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTitleElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGDescElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGNames.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGZoomAndPan.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGViewSpec.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGTSpanElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGGlyphElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGAltGlyphElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGHKernElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGMissingGlyphElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGFontElement.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/SVGFontData.cpp
#############################################################
## GRAPHICS #################################################
#############################################################
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGResource.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGPaintServer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/qt/SVGPaintServerQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGPaintServerSolid.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/qt/SVGPaintServerSolidQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGResourceClipper.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/qt/SVGResourceClipperQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGPaintServerGradient.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGPaintServerLinearGradient.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/SVGPaintServerRadialGradient.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/qt/SVGPaintServerGradientQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/qt/SVGPaintServerLinearGradientQt.cpp
  ${CMAKE_SOURCE_DIR}/khtml/svg/graphics/qt/SVGPaintServerRadialGradientQt.cpp
#############################################################
## RENDERING PART BELOW   ###################################
#############################################################
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGRoot.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderPath.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGRenderStyleDefs.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGRenderStyle.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGGradientStop.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGContainer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGRenderSupport.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGHiddenContainer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGTransformableContainer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGInlineFlowBox.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGRootInlineBox.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGTextPath.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGInlineTextBox.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/SVGCharacterLayoutInfo.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGInline.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGText.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGBlock.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGInlineText.cpp
  ${CMAKE_SOURCE_DIR}/khtml/rendering/RenderSVGTSpan.cpp
)

# khtml/dom/Makefile.am: khtmldom

set(khtmldom_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_misc.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_block.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_inline.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/css_rule.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_node.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_document.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_list.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/css_stylesheet.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_string.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_element.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_misc.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/css_value.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_text.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_object.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_doc.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_xml.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_head.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom_element.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_base.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_image.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_form.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom2_range.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/html_table.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom2_traversal.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom2_events.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom2_views.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/QualifiedName.cpp
  ${CMAKE_SOURCE_DIR}/khtml/dom/dom3_xpath.cpp
)

#set_source_files_properties(${khtmldom_STAT_SRCS} PROPERTIES COMPILE_FLAGS ${KDE4_ENABLE_EXCEPTIONS})

# khtml/misc/Makefile.am: khtmlmisc

set(khtmlmisc_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/misc/loader.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/helper.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/arena.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/stringit.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/paintbuffer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/imagefilter.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/borderarcstroker.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/idstring.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/htmlnames.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/AtomicString.cpp
  ${CMAKE_SOURCE_DIR}/khtml/misc/woff.cpp
)

set(khtmlediting_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/editing/jsediting.cpp
  ${CMAKE_SOURCE_DIR}/khtml/editing/editing.cpp
  ${CMAKE_SOURCE_DIR}/khtml/editing/editor.cpp
  ${CMAKE_SOURCE_DIR}/khtml/editing/htmlediting_impl.cpp
)

set(khtmlfind_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/ui/findbar/khtmlfind.cpp
  ${CMAKE_SOURCE_DIR}/khtml/ui/findbar/khtmlfindbar.cpp
)

kde4_add_ui_files(khtmlfind_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/ui/findbar/khtmlfindbar_base.ui
)

set(passwordbar_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/ui/passwordbar/storepassbar.cpp
)

kde4_add_ui_files(passwordbar_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/ui/passwordbar/storepassbar_base.ui
)

# khtml/html/Makefile.am: khtmlhtml

set(khtmlhtml_STAT_SRCS
  ${CMAKE_SOURCE_DIR}/khtml/html/htmlparser.cpp
  ${CMAKE_SOURCE_DIR}/khtml/html/htmltokenizer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/html/htmlprospectivetokenizer.cpp
  ${CMAKE_SOURCE_DIR}/khtml/html/dtd.cpp
  ${CMAKE_SOURCE_DIR}/khtml/html/html_headimpl.cpp
  ${CMAKE_SOURCE_DIR}/khtml/html/html_blockimpl.cpp
