=== doc/qtoptions/CMakeLists.txt ===
kde4_create_manpage(man-qtoptions.7.docbook 7 INSTALL_DESTINATION ${MAN_INSTALL_DIR})
