=== debian/changelog ===
kde4libs (4:4.14.16-0ubuntu3) xenial; urgency=medium

  * libkhtml5: Suggest kdelibs5-plugins instead of recommending it.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Feb 2016 17:23:12 +0100

kde4libs (4:4.14.16-0ubuntu2) xenial; urgency=medium

  * libkio5: Suggest kdelibs5-plugins instead of recommending it.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Feb 2016 13:08:02 +0100

kde4libs (4:4.14.16-0ubuntu1) xenial; urgency=medium

  * Fix VCS Url to point to the correct location
  * New upstream release 
    - refresh disable_bogus_test.diff
  * Refresh libkio5.symbols to remove missing internal symbols
  * Merge with debian git master 

 -- Philip Muškovac <yofel@kubuntu.org>  Sat, 21 Nov 2015 11:51:54 +0100

kde4libs (4:4.14.13-0ubuntu3) xenial; urgency=medium

  * Fix autopackagetests by adding allow-stderr to the requirements.

 -- Philip Muškovac <yofel@kubuntu.org>  Tue, 03 Nov 2015 15:34:34 +0100

kde4libs (4:4.14.13-0ubuntu2) xenial; urgency=medium

  * No-change rebuild for giflib soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 Oct 2015 10:09:21 +0000
